<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on January 20, 2010 at 6:49:55 pm</time-stamp>
<!-- Changes from: NGUBA-Application(Green.60,carry)  to: NGUBA-Application(Green.61,carry) -->


<methods>
<class-id>PROVISO.UBA.PvAggregator</class-id> <category>state recovery</category>

<body package="NGUBA-Application" selector="removeStateFilesOlderThanIndex:">removeStateFilesOlderThanIndex: stateIndex 
	
	| toRemove file |
	toRemove := 
		self stateFilesByTime 
			copyFrom: 1
			to: stateIndex - 1.
	toRemove do: 
		[:eachAssoc | 
		file := eachAssoc value.
		self system 
			logInfo: #DELETING_STATE_FILE
			text: 'Deleting state file ' , file asString , ' because it is too old'.
		file asFilename ifNotNil: 
			[:fn | 
			fn exists 
				ifTrue: [fn delete]
				ifFalse: 
					[self fileInterface stateCurrentDirectory , fn asString ifNotNil: 
						[:fname | 
						fname exists 
							ifTrue: [fname delete]]]]].
	self stateFilesByTime: 
		(self stateFilesByTime 
			copyFrom: stateIndex
			to: self stateFilesByTime size)</body>

<body package="NGUBA-Application" selector="removeStateFilesNewerThanIndex:">removeStateFilesNewerThanIndex: stateIndex 
	
	| file |
	stateIndex &lt; self stateFilesByTime size 
		ifTrue: 
			[stateIndex + 1 
				to: self stateFilesByTime size
				do: 
					[:ix | 
					file := (self stateFilesByTime at: ix) value.
					self system 
						logInfo: #DELETING_STATE_FILE
						text: 
							'Deleting state file ' , file asString , 
								' because state is rolled back to an earlier period'.
					file asFilename ifNotNil: 
						[:fn | 
						fn exists 
							ifTrue: [fn delete]
							ifFalse: 
								[self fileInterface stateCurrentDirectory , fn asString ifNotNil: 
									[:fname | 
									fname exists 
										ifTrue: [fname delete]]]]].
			self stateFilesByTime: 
				(self stateFilesByTime 
					copyFrom: 1
					to: stateIndex)]</body>
</methods>



</st-source>
